<?php

namespace FiloBlu\Newsletter\Block\Account\Create;

use FiloBlu\Newsletter\Block\Widget\Country;
use FiloBlu\Newsletter\Helper\Data;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Exception\NoSuchEntityException;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;

/**
 * Class AdditionalFields
 * @package FiloBlu\Newsletter\Block\Account\Create
 */
class AdditionalFields extends Template
{

    /**
     * Helper
     *
     * @var Data
     */
    public $_helper;

    /**
     * @var Country
     */
    public $_directoryBlock;

    /**
     * AdditionalFields constructor.
     * @param Context $context
     * @param array $data
     * @param Data $helper
     * @param Country $directoryBlock
     */
    public function __construct(
        Context $context,
        Data $helper,
        Country $directoryBlock,
        array $data = []
    )
    {
        $this->_helper = $helper;
        $this->_directoryBlock = $directoryBlock;

        parent::__construct($context, $data);
    }

    /**
     * @return string
     * @throws LocalizedException
     * @throws NoSuchEntityException
     */
    public function getCountries()
    {
        return $this->_directoryBlock->getCountryHtmlSelect();
    }

    /**
     * @return string
     */
    protected function _toHtml()
    {

        if (!$this->_helper->getConfig('general/enabled')) {
            return '';
        }

        return parent::_toHtml();
    }

}
